﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace ExternalUIFilter
{
    #region Data


    public class DataModel : INotifyPropertyChanged
    {
        private string _make;
        public string Make
        {
            get { return _make; }
            set
            {
                if (_make != value)
                {
                    _make = value;
                    OnPropertyChanged("Make");
                }
            }
        }
        private string _model;
        public string Model
        {
            get { return _model; }
            set
            {
                if (_model != value)
                {
                    _model = value;
                    OnPropertyChanged("Model");
                }
            }
        }
        private double _price;
        public double Price
        {
            get { return _price; }
            set
            {
                if (_price != value)
                {
                    _price = value;
                    OnPropertyChanged("Price");
                }
            }
        }
        private int _mileage;
        public int Mileage
        {
            get { return _mileage; }
            set
            {
                if (_mileage != value)
                {
                    _mileage = value;
                    OnPropertyChanged("Mileage");
                }
            }
        }
        private InnerData iData;
        public InnerData IData
        {
            get { return iData; }
            set
            {
                if (iData != value)
                {
                    iData = value;
                    OnPropertyChanged("IData");
                }
            }
        }

        #region INotifyPropertyChanged Members
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        #endregion
    }

    public class InnerData : INotifyPropertyChanged, IComparable
    {
        private double usdPrice;
        public double USDPrice
        {
            get { return usdPrice; }
            set
            {
                if (usdPrice != value)
                {
                    usdPrice = value;
                    OnPropertyChanged("USDPrice");
                }
            }
        }

        #region INotifyPropertyChanged Members
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public int CompareTo(object obj)
        {
            return this.USDPrice.CompareTo((obj as InnerData).USDPrice);
        }

        public event PropertyChangedEventHandler PropertyChanged;
        #endregion

    }


    #endregion
}
